%SCRIPT FOR PLOTTING THE WINDOWING FUNCTIONS
%
% Author: ZIPcores.com (2009)
% "Estimating polyphase filter coefficients with a windowed function"
% 
% 1. Lanczos2-windowed sinc
% 2. Blackman-windowed sinc
% 3. Hamming-windowed sinc
% 4. Kaizer-windowed sinc

% Lanczos2-windowed sinc over range -N/2,N/2
figure(1);
N = 5;
ks = -(N-1)/2:0.001:(N-1)/2;
kw = -(N-1)/2:0.001:(N-1)/2;

s = sinc(ks);
w = sinc(kw/2);

ws = s.*w;
%plot (ks,ws)
plot (ks,w)

% Blackman-windowed sinc over range -N/2,N/2
figure(2);
N = 5;
ks = -(N-1)/2:0.001:(N-1)/2;
kw = 0:0.001:(N-1);

s = sinc(ks);
w = 0.42 - 0.5*cos(2*pi*kw/(N-1)) + 0.08*cos(4*pi*kw/(N-1));

ws = s.*w;
%plot (ks,ws)
plot (ks,w)

% Hamming-windowed sinc over range -N/2,N/2
figure(3);
N = 5;
ks = -(N-1)/2:0.001:(N-1)/2;
kw = 0:0.001:(N-1);

s = sinc(ks);
w = 0.53836 - 0.46164*cos(2*pi*kw/(N-1));

ws = s.*w;
%plot (ks,ws)
plot (ks,w)

% Kaiser-windowed sinc over range -N/2,N/2
figure(4);
N = 5;
ks = -(N-1)/2:0.001:(N-1)/2;
kw = 0:0.001:(N-1);

s = sinc(ks);
alpha = 2*pi;
w = besseli(0,alpha*sqrt(1-(2*kw/(N-1) -1).^2))/besseli(0,alpha);

ws = s.*w;
%plot (ks,ws)
plot (ks,w)